
/* "grow3 extends water" means that there are a lot 
	of routines in water.java that this applet imports
	and uses, so if you want to understand this code, 
	read and understand water.java first.
	
	Special parameters:
		NUM_PARTS --  the number of dots to draw per iteration
			range 1-1000. Controls how fast patterns emerge/change
		tileSize -- how big to make the dots. Set to between 
			1 and 30.
		speed -- how fast the color varies. set to numbers in 
			the range 0 to 2000.
		mod -- whether or not to draw the dots on a grid.
			tileSize is the size fo the grid. Set to 0 or 1.
		
		how much to move the dots by is set by dxo, dyo, dxs, dys.
			dxo,dyo are the minimum allowable moves.
			dxs,dys are the range over dxo,dyo the move can vary
			look at how dX and dY are set in "initMore".
		
		
		
	
	Neal McDonald, this is my code, whosoever should
	leave in a pointer to me:
	www.workly.com
	*/
import java.awt.*;
import java.awt.image.*;
import java.applet.*;

public class tile extends water {
	double dX, dY, mx, my, mpx, mpy, colorSpeed;
	int tileSize, mod;
	
	void initPart(int which) {
		parts[which][XPOS] = dX*which;
		while (parts[which][XPOS]>mx) { parts[which][XPOS]-=mx; }
		parts[which][YPOS] = dY*which;
		while (parts[which][YPOS]>my) { parts[which][YPOS]-=my; }
		parts[which][OX] = Math.random() * imageX;
		parts[which][OY] = Math.random() * imageY;
		parts[which][SPEED] = colorSpeed;
		parts[which][DIR] = 0.0;
		
		partColors[which] = Color.white;
	}
	
	void initMore() {
		double dxo, dyo, dxs, dys;
		
		dxo = (double)java.lang.Integer.parseInt(getParameter("dxo"));
		dyo = (double)java.lang.Integer.parseInt(getParameter("dyo"));
		dxs = (double)java.lang.Integer.parseInt(getParameter("dxs"));
		dys = (double)java.lang.Integer.parseInt(getParameter("dys"));
		mod = java.lang.Integer.parseInt(getParameter("mod"));
		colorSpeed = 0.01 * (double)java.lang.Integer.parseInt(getParameter("colorSpeed"));
		 

		dX = ((int)((Math.random() * dxs + dxo)*1000))/1000.0;
		dY = ((int)((Math.random() * dys + dxo)*1000))/1000.0;
		mx = (double)size().width;
		my = (double)size().height;
		tileSize = java.lang.Integer.parseInt(getParameter("tileSize"));

	}
	
	void drawPart(Graphics gr, int which) {
		int px,py, cx,cy;
	
		px = (int)parts[which][XPOS];
		py = (int)parts[which][YPOS];

		if (mod==1) {
			px = px-(px%tileSize);
			py = py-(py%tileSize);
		}
		r_setColor(gr, partColors[0]); 
		r_fillRect(gr, px, py, tileSize, tileSize);
		r_fillRect(gr, py, px, tileSize, tileSize);
		
		//r_setColor(gr, Color.white);
		//r_fillRect(gr, cx-1, cy-1, 3, 3);
		
	}	
	
	void movePart(int which) {
		double px, py, dd;
		int d;
		if (which==0) {
			px = parts[NUM_PARTS-1][XPOS] + dX;
			py = parts[NUM_PARTS-1][YPOS] + dY;
		} else {
			px = parts[which-1][XPOS] + dX;
			py = parts[which-1][YPOS] + dY;
		}
		if (px>mx) { px-=mx; }
		if (py>my) { py-=my; }
		parts[which][XPOS] = px;
		parts[which][YPOS] = py;

		if (which==0) {
			px = parts[which][OX];
			py = parts[which][OY];
			parts[which][DIR] += ((Math.random()*20.0) - 10.0);
			d = ((int)parts[which][DIR])%360;
			if (d<0) d+=360;
			px += parts[which][SPEED] * cosines[d];
			py += parts[which][SPEED] * sines[d];
					mpx = (double)imageX;
					mpy = (double)imageY;

			if (px>mpx) { px=0.0; }
			if (py>mpy) { py=0.0; }
			if (px<0.0) { px=mpx; }
			if (py<0.0) { py=mpy; }
			parts[which][OX] = px;
			parts[which][OY] = py;
			
			partColors[which] = getColorC((int)px, (int)py);
			// partColors[which] = Color.white;
		}			
	}
}

